/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
)

// checks if the ApplicationRegistration type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ApplicationRegistration{}

// ApplicationRegistration struct for ApplicationRegistration
type ApplicationRegistration struct {
	RegistrationId      *string        `json:"registrationId,omitempty"`
	RegistrationName    NullableString `json:"registrationName,omitempty"`
	ProviderIdentifier  NullableString `json:"providerIdentifier,omitempty"`
	ProviderDisplayName NullableString `json:"providerDisplayName,omitempty"`
	ProviderDescription NullableString `json:"providerDescription,omitempty"`
	Registration        interface{}    `json:"registration,omitempty"`
}

// NewApplicationRegistration instantiates a new ApplicationRegistration object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewApplicationRegistration() *ApplicationRegistration {
	this := ApplicationRegistration{}
	return &this
}

// NewApplicationRegistrationWithDefaults instantiates a new ApplicationRegistration object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewApplicationRegistrationWithDefaults() *ApplicationRegistration {
	this := ApplicationRegistration{}
	return &this
}

// GetRegistrationId returns the RegistrationId field value if set, zero value otherwise.
func (o *ApplicationRegistration) GetRegistrationId() string {
	if o == nil || IsNil(o.RegistrationId) {
		var ret string
		return ret
	}
	return *o.RegistrationId
}

// GetRegistrationIdOk returns a tuple with the RegistrationId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ApplicationRegistration) GetRegistrationIdOk() (*string, bool) {
	if o == nil || IsNil(o.RegistrationId) {
		return nil, false
	}
	return o.RegistrationId, true
}

// HasRegistrationId returns a boolean if a field has been set.
func (o *ApplicationRegistration) HasRegistrationId() bool {
	if o != nil && !IsNil(o.RegistrationId) {
		return true
	}

	return false
}

// SetRegistrationId gets a reference to the given string and assigns it to the RegistrationId field.
func (o *ApplicationRegistration) SetRegistrationId(v string) {
	o.RegistrationId = &v
}

// GetRegistrationName returns the RegistrationName field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *ApplicationRegistration) GetRegistrationName() string {
	if o == nil || IsNil(o.RegistrationName.Get()) {
		var ret string
		return ret
	}
	return *o.RegistrationName.Get()
}

// GetRegistrationNameOk returns a tuple with the RegistrationName field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *ApplicationRegistration) GetRegistrationNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.RegistrationName.Get(), o.RegistrationName.IsSet()
}

// HasRegistrationName returns a boolean if a field has been set.
func (o *ApplicationRegistration) HasRegistrationName() bool {
	if o != nil && o.RegistrationName.IsSet() {
		return true
	}

	return false
}

// SetRegistrationName gets a reference to the given NullableString and assigns it to the RegistrationName field.
func (o *ApplicationRegistration) SetRegistrationName(v string) {
	o.RegistrationName.Set(&v)
}

// SetRegistrationNameNil sets the value for RegistrationName to be an explicit nil
func (o *ApplicationRegistration) SetRegistrationNameNil() {
	o.RegistrationName.Set(nil)
}

// UnsetRegistrationName ensures that no value is present for RegistrationName, not even an explicit nil
func (o *ApplicationRegistration) UnsetRegistrationName() {
	o.RegistrationName.Unset()
}

// GetProviderIdentifier returns the ProviderIdentifier field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *ApplicationRegistration) GetProviderIdentifier() string {
	if o == nil || IsNil(o.ProviderIdentifier.Get()) {
		var ret string
		return ret
	}
	return *o.ProviderIdentifier.Get()
}

// GetProviderIdentifierOk returns a tuple with the ProviderIdentifier field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *ApplicationRegistration) GetProviderIdentifierOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.ProviderIdentifier.Get(), o.ProviderIdentifier.IsSet()
}

// HasProviderIdentifier returns a boolean if a field has been set.
func (o *ApplicationRegistration) HasProviderIdentifier() bool {
	if o != nil && o.ProviderIdentifier.IsSet() {
		return true
	}

	return false
}

// SetProviderIdentifier gets a reference to the given NullableString and assigns it to the ProviderIdentifier field.
func (o *ApplicationRegistration) SetProviderIdentifier(v string) {
	o.ProviderIdentifier.Set(&v)
}

// SetProviderIdentifierNil sets the value for ProviderIdentifier to be an explicit nil
func (o *ApplicationRegistration) SetProviderIdentifierNil() {
	o.ProviderIdentifier.Set(nil)
}

// UnsetProviderIdentifier ensures that no value is present for ProviderIdentifier, not even an explicit nil
func (o *ApplicationRegistration) UnsetProviderIdentifier() {
	o.ProviderIdentifier.Unset()
}

// GetProviderDisplayName returns the ProviderDisplayName field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *ApplicationRegistration) GetProviderDisplayName() string {
	if o == nil || IsNil(o.ProviderDisplayName.Get()) {
		var ret string
		return ret
	}
	return *o.ProviderDisplayName.Get()
}

// GetProviderDisplayNameOk returns a tuple with the ProviderDisplayName field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *ApplicationRegistration) GetProviderDisplayNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.ProviderDisplayName.Get(), o.ProviderDisplayName.IsSet()
}

// HasProviderDisplayName returns a boolean if a field has been set.
func (o *ApplicationRegistration) HasProviderDisplayName() bool {
	if o != nil && o.ProviderDisplayName.IsSet() {
		return true
	}

	return false
}

// SetProviderDisplayName gets a reference to the given NullableString and assigns it to the ProviderDisplayName field.
func (o *ApplicationRegistration) SetProviderDisplayName(v string) {
	o.ProviderDisplayName.Set(&v)
}

// SetProviderDisplayNameNil sets the value for ProviderDisplayName to be an explicit nil
func (o *ApplicationRegistration) SetProviderDisplayNameNil() {
	o.ProviderDisplayName.Set(nil)
}

// UnsetProviderDisplayName ensures that no value is present for ProviderDisplayName, not even an explicit nil
func (o *ApplicationRegistration) UnsetProviderDisplayName() {
	o.ProviderDisplayName.Unset()
}

// GetProviderDescription returns the ProviderDescription field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *ApplicationRegistration) GetProviderDescription() string {
	if o == nil || IsNil(o.ProviderDescription.Get()) {
		var ret string
		return ret
	}
	return *o.ProviderDescription.Get()
}

// GetProviderDescriptionOk returns a tuple with the ProviderDescription field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *ApplicationRegistration) GetProviderDescriptionOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.ProviderDescription.Get(), o.ProviderDescription.IsSet()
}

// HasProviderDescription returns a boolean if a field has been set.
func (o *ApplicationRegistration) HasProviderDescription() bool {
	if o != nil && o.ProviderDescription.IsSet() {
		return true
	}

	return false
}

// SetProviderDescription gets a reference to the given NullableString and assigns it to the ProviderDescription field.
func (o *ApplicationRegistration) SetProviderDescription(v string) {
	o.ProviderDescription.Set(&v)
}

// SetProviderDescriptionNil sets the value for ProviderDescription to be an explicit nil
func (o *ApplicationRegistration) SetProviderDescriptionNil() {
	o.ProviderDescription.Set(nil)
}

// UnsetProviderDescription ensures that no value is present for ProviderDescription, not even an explicit nil
func (o *ApplicationRegistration) UnsetProviderDescription() {
	o.ProviderDescription.Unset()
}

// GetRegistration returns the Registration field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *ApplicationRegistration) GetRegistration() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.Registration
}

// GetRegistrationOk returns a tuple with the Registration field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *ApplicationRegistration) GetRegistrationOk() (*interface{}, bool) {
	if o == nil || IsNil(o.Registration) {
		return nil, false
	}
	return &o.Registration, true
}

// HasRegistration returns a boolean if a field has been set.
func (o *ApplicationRegistration) HasRegistration() bool {
	if o != nil && !IsNil(o.Registration) {
		return true
	}

	return false
}

// SetRegistration gets a reference to the given interface{} and assigns it to the Registration field.
func (o *ApplicationRegistration) SetRegistration(v interface{}) {
	o.Registration = v
}

func (o ApplicationRegistration) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ApplicationRegistration) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.RegistrationId) {
		toSerialize["registrationId"] = o.RegistrationId
	}
	if o.RegistrationName.IsSet() {
		toSerialize["registrationName"] = o.RegistrationName.Get()
	}
	if o.ProviderIdentifier.IsSet() {
		toSerialize["providerIdentifier"] = o.ProviderIdentifier.Get()
	}
	if o.ProviderDisplayName.IsSet() {
		toSerialize["providerDisplayName"] = o.ProviderDisplayName.Get()
	}
	if o.ProviderDescription.IsSet() {
		toSerialize["providerDescription"] = o.ProviderDescription.Get()
	}
	if o.Registration != nil {
		toSerialize["registration"] = o.Registration
	}
	return toSerialize, nil
}

type NullableApplicationRegistration struct {
	value *ApplicationRegistration
	isSet bool
}

func (v NullableApplicationRegistration) Get() *ApplicationRegistration {
	return v.value
}

func (v *NullableApplicationRegistration) Set(val *ApplicationRegistration) {
	v.value = val
	v.isSet = true
}

func (v NullableApplicationRegistration) IsSet() bool {
	return v.isSet
}

func (v *NullableApplicationRegistration) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableApplicationRegistration(val *ApplicationRegistration) *NullableApplicationRegistration {
	return &NullableApplicationRegistration{value: val, isSet: true}
}

func (v NullableApplicationRegistration) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableApplicationRegistration) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
